Summary:    Sangoma SSH Keys
Name:       ssh_keys

Version:    3.0
Release:    5%{dist}
License:    MIT
Source:     ssh_keys-3.0.tar.gz
BuildArch:  noarch
Group:      System/Servers
BuildRoot:  %{_builddir}/%{name}-%{version}
Vendor:     Sangoma Technologies
Packager:   Rob Thomas <rthomas@sangoma.com>

AutoReqProv: no

%description
This package adds a selection of SSH Keys to your system to allow easy and secure access
by Sangoma Support Staff.  When you remove this package, all keys that have been added
are removed, without disturbing any other keys you may have added.

%prep
%setup


%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/etc/sangoma
echo "# This file contains the current SSH Keys of Sangoma Staff" >  %{buildroot}/etc/sangoma/ssh-keys
echo "# and should not be altered. It is managed by the 'ssh_keys' RPM" >>  %{buildroot}/etc/sangoma/ssh-keys
cat authorized_keys/* >> %{buildroot}/etc/sangoma/ssh-keys

%pre
# This is run BEFORE anything is installed, or on an upgrade

# Ensure that none of the old ssh_keys keys are still here.
# Load the authorized_keys file, removing any keys that
# we have previously added.
VALIDLINES=()
KEYFILE=/root/.ssh/authorized_keys
mkdir -p /root/.ssh
touch $KEYFILE
while read type key descr; do
        [ "$descr" == "Managed Sangoma Key" ] && continue
        [ "$key" == "SANGOMA:" ] && continue

	# This section filters out any of the old keys from the previous RPM
	[[ $descr == sysadmin-* ]] && continue
	[ "$descr" == "rk@schmoozecom.net" -o "$descr" == "qwell@qwell" -o "$descr" == "xrobau" -o "$descr" == "james@james-laptop" ] && continue

	# Anything left over is good to go.
        VALIDLINES+=("$type $key $descr")
done < $KEYFILE

echo "# SANGOMA: File generated at `date +%c`" > $KEYFILE
for line in "${VALIDLINES[@]}"; do
        echo $line >> $KEYFILE
done

%post
# This is run AFTER the /etc/sangoma/ssh-keys file is created, or updated
KEYFILE=/root/.ssh/authorized_keys
echo "# SANGOMA: The following keys have been added by the ssh_keys RPM, and" >> $KEYFILE
echo "# SANGOMA: will be automatically removed if you run 'yum remove ssh_keys'" >> $KEYFILE
echo "# SANGOMA: IMPORTANT WARNING!" >> $KEYFILE
echo "# SANGOMA: If you change the description of one of the following keys, it" >> $KEYFILE
echo "# SANGOMA: will NOT be treated as a managed key, and will be preserved." >> $KEYFILE

while read type key desc; do
  # Skip comments
  [[ "$type" == "#" ]] && continue
  # Skip blank lines (there shouldn't be any though...)
  [[ ! "$type" ]] && continue
  echo $type $key Managed Sangoma Key >> $KEYFILE
done < /etc/sangoma/ssh-keys


%postun
if [ "$1" == "0" ]; then
  # We're being uninstalled. Nicely remove our stuff, please
  KEYFILE=/root/.ssh/authorized_keys
  VALIDLINES=()
  while read type key descr; do
    [ "$descr" == "Managed Sangoma Key" ] && continue
    [ "$key" == "SANGOMA:" ] && continue
    VALIDLINES+=("$type $key $descr")
  done < $KEYFILE
  echo -n "" > $KEYFILE
  for line in "${VALIDLINES[@]}"; do
   echo $line >> $KEYFILE
  done
fi

%clean
#rm -rf %{buildroot}

%files
%defattr(-,root,root)
/etc/sangoma/ssh-keys
